local rName = GetRealmName();
local pName = UnitName("player");
local ooprocessed = 0;
frspversion = GetAddOnMetadata("flagRSP2", "Version");
rspsendbuffer = {};

local defaults = {
    profile = {
		flagRSP2OptionsSaveDescCheck = true,
		flagRSP2OptionsShowDescCheck = true,
		flagRSP2OptionsTargetDescCheck = false,
		flagRSP2OptionsStickyDescCheck = false,
		flagRSP2OptionsHideCombatCheck = true,
		flagRSP2OptionsWordLimitCheck = false,
		flagRSP2OptionsAFKCheck = true,

		flagRSP2TooltipLightModeCheck = false,
		flagRSP2TooltipFRSP2TTCheck = true,
		flagRSP2TooltipShowAddNameCheck = true,
		flagRSP2TooltipShowTitleCheck = true,
		flagRSP2TooltipShowGuildCheck = true,
		flagRSP2TooltipShowStatusCheck = true,
		flagRSP2TooltipShowPvPCheck = false,
		flagRSP2TooltipShowPvPTitleCheck = false,
		flagRSP2DescShowTitleCheck = true,
		flagRSP2DescShowStatusCheck = true,
    },
}



--General Options
function flagRSP2:GetflagRSP2OptionsSaveDescCheck()
	return self.db.profile.flagRSP2OptionsSaveDescCheck
end
function flagRSP2:SetflagRSP2OptionsSaveDescCheck()
	self.db.profile.flagRSP2OptionsSaveDescCheck = not self.db.profile.flagRSP2OptionsSaveDescCheck
end
function flagRSP2:GetflagRSP2OptionsShowDescCheck()
	return self.db.profile.flagRSP2OptionsShowDescCheck
end
function flagRSP2:SetflagRSP2OptionsShowDescCheck()
	self.db.profile.flagRSP2OptionsShowDescCheck = not self.db.profile.flagRSP2OptionsShowDescCheck
end
function flagRSP2:GetflagRSP2OptionsTargetDescCheck()
	return self.db.profile.flagRSP2OptionsTargetDescCheck
end
function flagRSP2:SetflagRSP2OptionsTargetDescCheck()
	self.db.profile.flagRSP2OptionsTargetDescCheck = not self.db.profile.flagRSP2OptionsTargetDescCheck
end
function flagRSP2:GetflagRSP2OptionsStickyDescCheck()
	return self.db.profile.flagRSP2OptionsStickyDescCheck
end
function flagRSP2:SetflagRSP2OptionsStickyDescCheck()
	self.db.profile.flagRSP2OptionsStickyDescCheck = not self.db.profile.flagRSP2OptionsStickyDescCheck
end
function flagRSP2:GetflagRSP2OptionsHideCombatCheck()
	return self.db.profile.flagRSP2OptionsHideCombatCheck
end
function flagRSP2:SetflagRSP2OptionsHideCombatCheck()
	self.db.profile.flagRSP2OptionsHideCombatCheck = not self.db.profile.flagRSP2OptionsHideCombatCheck
end
function flagRSP2:GetflagRSP2OptionsWordLimitCheck()
	return self.db.profile.flagRSP2OptionsWordLimitCheck
end
function flagRSP2:SetflagRSP2OptionsWordLimitCheck()
	self.db.profile.flagRSP2OptionsWordLimitCheck = not self.db.profile.flagRSP2OptionsWordLimitCheck
end
function flagRSP2:GetflagRSP2OptionsAFKCheck()
	return self.db.profile.flagRSP2OptionsAFKCheck
end
function flagRSP2:SetflagRSP2OptionsAFKCheck()
	self.db.profile.flagRSP2OptionsAFKCheck = not self.db.profile.flagRSP2OptionsAFKCheck
end

--Tooltip/Description Pop Up Options
function flagRSP2:GetflagRSP2TooltipLightModeCheck()
	return self.db.profile.flagRSP2TooltipLightModeCheck
end
function flagRSP2:SetflagRSP2TooltipLightModeCheck()
	self.db.profile.flagRSP2TooltipLightModeCheck = not self.db.profile.flagRSP2TooltipLightModeCheck
end
function flagRSP2:GetflagRSP2TooltipFRSP2TTCheck()
	return self.db.profile.flagRSP2TooltipFRSP2TTCheck
end
function flagRSP2:SetflagRSP2TooltipFRSP2TTCheck()
	self.db.profile.flagRSP2TooltipFRSP2TTCheck = not self.db.profile.flagRSP2TooltipFRSP2TTCheck
end
function flagRSP2:GetflagRSP2TooltipShowAddNameCheck()
	return self.db.profile.flagRSP2TooltipShowAddNameCheck
end
function flagRSP2:SetflagRSP2TooltipShowAddNameCheck()
	self.db.profile.flagRSP2TooltipShowAddNameCheck = not self.db.profile.flagRSP2TooltipShowAddNameCheck
end
function flagRSP2:GetflagRSP2TooltipShowTitleCheck()
	return self.db.profile.flagRSP2TooltipShowTitleCheck
end
function flagRSP2:SetflagRSP2TooltipShowTitleCheck()
	self.db.profile.flagRSP2TooltipShowTitleCheck = not self.db.profile.flagRSP2TooltipShowTitleCheck
end
function flagRSP2:GetflagRSP2TooltipShowGuildCheck()
	return self.db.profile.flagRSP2TooltipShowGuildCheck
end
function flagRSP2:SetflagRSP2TooltipShowGuildCheck()
	self.db.profile.flagRSP2TooltipShowGuildCheck = not self.db.profile.flagRSP2TooltipShowGuildCheck
end
function flagRSP2:GetflagRSP2TooltipShowStatusCheck()
	return self.db.profile.flagRSP2TooltipShowStatusCheck
end
function flagRSP2:SetflagRSP2TooltipShowStatusCheck()
	self.db.profile.flagRSP2TooltipShowStatusCheck = not self.db.profile.flagRSP2TooltipShowStatusCheck
end
function flagRSP2:GetflagRSP2TooltipShowPvPCheck()
	return self.db.profile.flagRSP2TooltipShowPvPCheck
end
function flagRSP2:SetflagRSP2TooltipShowPvPCheck()
	self.db.profile.flagRSP2TooltipShowPvPCheck = not self.db.profile.flagRSP2TooltipShowPvPCheck
end
function flagRSP2:GetflagRSP2TooltipShowPvPTitleCheck()
	return self.db.profile.flagRSP2TooltipShowPvPTitleCheck
end
function flagRSP2:SetflagRSP2TooltipShowPvPTitleCheck()
	self.db.profile.flagRSP2TooltipShowPvPTitleCheck = not self.db.profile.flagRSP2TooltipShowPvPTitleCheck
end
function flagRSP2:GetflagRSP2DescShowTitleCheck()
	return self.db.profile.flagRSP2DescShowTitleCheck
end
function flagRSP2:SetflagRSP2DescShowTitleCheck()
	self.db.profile.flagRSP2DescShowTitleCheck = not self.db.profile.flagRSP2DescShowTitleCheck
end
function flagRSP2:GetflagRSP2DescShowStatusCheck()
	return self.db.profile.flagRSP2DescShowStatusCheck
end
function flagRSP2:SetflagRSP2DescShowStatusCheck()
	self.db.profile.flagRSP2DescShowStatusCheck = not self.db.profile.flagRSP2DescShowStatusCheck
end

local optionsvname = "flagRSP2 " .. frspversion

options = {
	name = "flagRSP2 " .. GetAddOnMetadata("flagRSP2", "Version"),
	handler = flagRSP2,
	type = 'group',
	args = {
		frsp2options = {
			name = "flagRSP2",
			desc = '',
			order = 1,
			type = 'group',
			args = {
				General = {
					name = "flagRSP2 " .. GetAddOnMetadata("flagRSP2", "Version") .. " General Options",
					type = 'group',
					order = 1,
					guiInline = true,
					args = {
						flagRSP2OptionsSaveDescCheck = {
							type = 'toggle',
							name = FLAGRSP2_SAVE_DESCRIPTIONS,
							desc = "Turning off the saving of descriptions will save on memory, but severely limits the functionality of FlagRSP2.  Additional names, titles, and status will still be saved.  Note: Any previously saved descriptions will still be kept unless you purge the database.",
							get = "GetflagRSP2OptionsSaveDescCheck",
							set = "SetflagRSP2OptionsSaveDescCheck",
							width = 'full',
							order = 2,
						},
						flagRSP2OptionsShowDescCheck = {
							type = 'toggle',
							name = FLAGRSP2_SHOW_TARGET_CHARACTER_DESCRIPTION,
							desc = "Show the description window for players.  Turning this off prevents descriptions from ever showing.",
							get = "GetflagRSP2OptionsShowDescCheck",
							set = "SetflagRSP2OptionsShowDescCheck",
							width = 'full',
							order = 3,
						},
						flagRSP2OptionsTargetDescCheck = {
							type = 'toggle',
							name = FLAGRSP2_SHOW_DESCRIPTION_ONLY_WHEN_TARGETTING_PLAYER,
							desc = "Show the description window only when targetting a player, not when mousing over the player.",
							get = "GetflagRSP2OptionsTargetDescCheck",
							set = "SetflagRSP2OptionsTargetDescCheck",
							width = 'full',
							order = 4,
						},
						flagRSP2OptionsStickyDescCheck = {
							type = 'toggle',
							name = FLAGRSP2_STICKY_DESCRIPTION,
							desc = "Keeps the description window until you close it manually.",
							get = "GetflagRSP2OptionsStickyDescCheck",
							set = "SetflagRSP2OptionsStickyDescCheck",
							width = 'full',
							order = 5,
						},
						flagRSP2OptionsHideCombatCheck = {
							type = 'toggle',
							name = FLAGRSP2_HIDE_DESCRIPTIONS_DURING_AND_ENTERING_COMBAT,
							desc = "When you enter combat the descriptions window will be prevented from appearing.",
							get = "GetflagRSP2OptionsHideCombatCheck",
							set = "SetflagRSP2OptionsHideCombatCheck",
							width = 'full',
							order = 6,
						},
						flagRSP2OptionsWordLimitCheck = {
							type = 'toggle',
							name = FLAGRSP2_CUT_OFF_TITLES,
							desc = "Prevents long tool tips from obscuring the screen.",
							get = "GetflagRSP2OptionsWordLimitCheck",
							set = "SetflagRSP2OptionsWordLimitCheck",
							width = 'full',
							order = 7,
						},
						flagRSP2OptionsAFKCheck = {
							type = 'toggle',
							name = FLAGRSP2_AFK,
							desc = "Synchronizing while away from the keyboard can cause you to automatically come back from being AFK.",
							get = "GetflagRSP2OptionsAFKCheck",
							set = "SetflagRSP2OptionsAFKCheck",
							width = 'full',
							order = 8,
						},
					},
				},
				gametooltip = {
					name = 'Enhanced GameTooltip',
					type = 'group',
					order = 9,
					guiInline = true,
					args = {
						flagRSP2TooltipLightModeCheck = {
							type = 'toggle',
							name = FLAGRSP2_LIGHT_MODE_TOOLTIP,
							desc = "Disable enhanced gametooltip and use the default gametooltip.  Use this if you do not like the colorized look of the tooltip or prefer to use another AddOn to format the tooltip.",
							get = "GetflagRSP2TooltipLightModeCheck",
							set = "SetflagRSP2TooltipLightModeCheck",
							width = 'full',
							order = 9,
						},
						flagRSP2TooltipShowAddNameCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_ADDITIONAL_NAME,
							desc = "",
							get = "GetflagRSP2TooltipShowAddNameCheck",
							set = "SetflagRSP2TooltipShowAddNameCheck",
							width = 'full',
							order = 10,
						},
						flagRSP2TooltipShowTitleCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_TITLE,
							desc = "",
							get = "GetflagRSP2TooltipShowTitleCheck",
							set = "SetflagRSP2TooltipShowTitleCheck",
							width = 'full',
							order = 11,
						},
						flagRSP2TooltipShowGuildCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_GUILD,
							desc = "",
							get = "GetflagRSP2TooltipShowGuildCheck",
							set = "SetflagRSP2TooltipShowGuildCheck",
							width = 'full',
							order = 12,
						},
						flagRSP2TooltipShowStatusCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_STATUS,
							desc = "",
							get = "GetflagRSP2TooltipShowStatusCheck",
							set = "SetflagRSP2TooltipShowStatusCheck",
							width = 'full',
							order = 13,
						},
						flagRSP2TooltipShowPvPCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_PVP,
							desc = "",
							get = "GetflagRSP2TooltipShowPvPCheck",
							set = "SetflagRSP2TooltipShowPvPCheck",
							width = 'full',
							order = 14,
						},
						flagRSP2TooltipShowPvPTitleCheck = {
							type = 'toggle',
							name = FLAGRSP2_ENHANCED_PVP_TITLE,
							desc = "",
							get = "GetflagRSP2TooltipShowPvPTitleCheck",
							set = "SetflagRSP2TooltipShowPvPTitleCheck",
							width = 'full',
							order = 15,
						},
					},
				},

				descpopup = {
					name = FLAGRSP2_DESC_OPT_ROCK,
					type = 'description',
					type = 'group',
					order = 16,
					guiInline = true,
					args = {
						flagRSP2DescShowTitleCheck = {
							type = 'toggle',
							name = FLAGRSP2_DESC_TITLE,
							desc = "",
							get = "GetflagRSP2DescShowTitleCheck",
							set = "SetflagRSP2DescShowTitleCheck",
							width = 'full',
							order = 17,
						},
						flagRSP2DescShowStatusCheck = {
							type = 'toggle',
							name = FLAGRSP2_DESC_STATUS,
							desc = "",
							get = "GetflagRSP2DescShowStatusCheck",
							set = "SetflagRSP2DescShowStatusCheck",
							width = 'full',
							order = 18,
						},
					},
				},
				dbcleanup = {
					name = FLAGRSP2_DB_CLEAN_UP,
					type = 'description',
					type = 'group',
					order = 19,
					guiInline = true,
					args = {
						purgeselectivedb = {
							type = 'execute',
							name = FLAGRSP2_DB_PURGE_OLD,
							desc = "Delete character entries over thirty days old.",
							func = function() flagRSP2PurgeOldDB() end,
							order = 20,
						},
						purgealldb = {
							type = 'execute',
							name = FLAGRSP2_DB_PURGE_ALL,
							desc = "Delete all character entries from other players.  This does not affect your own characters.",
							func = function() flagRSP2PurgeAllDB() end,
							order = 21,
						},
					},
				},
			},
		},
	},
}

function flagRSP2Options_Initialize()
	if (FlagList == nil) then
		FlagList = {};
	end
	if (FlagList[rName] == nil) then
		FlagList[rName] = {};
	end
	if (PlayerFlags == nil) then
		PlayerFlags = {};	
	end
	if (PlayerFlags[rName] == nil) then
		PlayerFlags[rName] = {};
	end
	if (PlayerFlags[rName][pName] == nil) then
		PlayerFlags[rName][pName] = {};
	end
	if (PlayerFlags[rName][pName]["CS"] == nil) then
		PlayerFlags[rName][pName]["CS"] = 2;
		flagRSP2OptionsCSSlider:SetValue(PlayerFlags[rName][pName]["CS"])
	else
		flagRSP2OptionsCSSlider:SetValue(PlayerFlags[rName][pName]["CS"])
	end
	if (PlayerFlags[rName][pName]["RP"] == nil) then
		PlayerFlags[rName][pName]["RP"] = 2;
		flagRSP2OptionsRPSlider:SetValue(PlayerFlags[rName][pName]["RP"])
	else
		flagRSP2OptionsRPSlider:SetValue(PlayerFlags[rName][pName]["RP"])
	end
	if (PlayerFlags[rName][pName]["FName"] == nil) then
		PlayerFlags[rName][pName]["FName"] = "";
	else
		flagRSP2PlayerFNameEdit:SetText(PlayerFlags[rName][pName]["FName"]);
	end
	if (PlayerFlags[rName][pName]["LName"] == nil) then
		PlayerFlags[rName][pName]["LName"] = "";
	else
		flagRSP2PlayerLNameEdit:SetText(PlayerFlags[rName][pName]["LName"]);
	end
	flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
	if (PlayerFlags[rName][pName]["Title"] == nil) then
		PlayerFlags[rName][pName]["Title"] = "";
	else
		flagRSP2PlayerTitleEdit:SetText(PlayerFlags[rName][pName]["Title"]);
	end
	if (PlayerFlags[rName][pName]["Desc"] == nil) then
		PlayerFlags[rName][pName]["Desc"] = {};
		PlayerFlags[rName][pName]["Desc"]["A"] = "";
	else
		flagRSP2PlayerDescEdit:SetText(PlayerFlags[rName][pName]["Desc"]["A"]);
	end

	if (PlayerFlags[rName][pName]["DV"] == nil) then
		PlayerFlags[rName][pName]["DV"] = -1;
	end

	FRSPLOADED = 1;
end

function flagRSP2AdvOptions_Update(option)
	statusupdate = 0;
	if (option == "timedupdate") then
		statusupdate = 1;
	end
	if (option == "textsendupdate" and textsendupdate == 1) then
		statusupdate = 1;
		textsendupdate = 0;
		if (descupdate == 1) then
			PlayerFlags[rName][pName]["DV"] = PlayerFlags[rName][pName]["DV"] + 1;
			descupdate = 0;
		end
	end
	if (option == flagRSP2OptionsCSSlider or option == flagRSP2OptionsRPSlider) then
		if (option == flagRSP2OptionsCSSlider) then
			if (PlayerFlags[rName][pName]["CS"] ~= flagRSP2OptionsCSSlider:GetValue()) then
				statusupdate = 1;
			end
			PlayerFlags[rName][pName]["CS"] = flagRSP2OptionsCSSlider:GetValue();
			if (PlayerFlags[rName][pName]["CS"] == 0) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_CSH);
			elseif (PlayerFlags[rName][pName]["CS"] == 1) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_OOC);
			elseif (PlayerFlags[rName][pName]["CS"] == 2) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_IC);
			elseif (PlayerFlags[rName][pName]["CS"] == 3) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_LFC);
			elseif (PlayerFlags[rName][pName]["CS"] == 4) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_ST);
			end
		end
		if (option == flagRSP2OptionsRPSlider) then
			if (PlayerFlags[rName][pName]["RP"] ~= flagRSP2OptionsRPSlider:GetValue()) then
				statusupdate = 1;
			end
			PlayerFlags[rName][pName]["RP"] = flagRSP2OptionsRPSlider:GetValue();
			if (PlayerFlags[rName][pName]["RP"] == 0) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_RSH);
			elseif (PlayerFlags[rName][pName]["RP"] == 1) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_RP);
			elseif (PlayerFlags[rName][pName]["RP"] == 2) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_CRP);
			elseif (PlayerFlags[rName][pName]["RP"] == 3) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_FRP);
			elseif (PlayerFlags[rName][pName]["RP"] == 4) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_BRP);
			elseif (PlayerFlags[rName][pName]["RP"] == 5) then
				getglobal(this:GetName().."Text"):SetText(FLAGRSP2_LUA_MRP);
			end
		end
	end

	if (option == flagRSP2PlayerFNameEdit) then
		PlayerFlags[rName][pName]["FName"] = flagRSP2PlayerFNameEdit:GetText();
		flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
		textsendupdate = 1;
	end
	if (option == flagRSP2PlayerLNameEdit) then
		PlayerFlags[rName][pName]["LName"] = flagRSP2PlayerLNameEdit:GetText();
		flagRSP2Player_NameDisplayText:SetText(PlayerFlags[rName][pName]["FName"] .. " " .. pName .. " " .. PlayerFlags[rName][pName]["LName"]);
		textsendupdate = 1;
	end
	if (option == flagRSP2PlayerTitleEdit) then
		PlayerFlags[rName][pName]["Title"] = flagRSP2PlayerTitleEdit:GetText();
		textsendupdate = 1;
	end
	if (option == flagRSP2PlayerDescEdit) then
		if (PlayerFlags[rName][pName]["Desc"]["A"] ~= flagRSP2PlayerDescEdit:GetText()) then
			PlayerFlags[rName][pName]["Desc"]["A"] = flagRSP2PlayerDescEdit:GetText();
			descupdate = 1;
			textsendupdate = 1;
		end
	end

	--Time to compose simple update messages.  Everything except for description will be sent in this step.  CSM stands for composed simple message.
	if (statusupdate == 1) then
		csm = "";
		csm = "<CS" .. PlayerFlags[rName][pName]["CS"] .. ">";
		csm = csm .. "<RP" .. PlayerFlags[rName][pName]["RP"] .. ">";
		csm = csm .. "<DV>" .. PlayerFlags[rName][pName]["DV"] .. "<AN1>" .. PlayerFlags[rName][pName]["FName"] .. "<AN3>" .. PlayerFlags[rName][pName]["LName"];
		flagRSP2:AddToBuffer(csm);
		csmt = "<T>" .. string.sub(PlayerFlags[rName][pName]["Title"], 1, 252);
		flagRSP2:AddToBuffer(csmt);
		statusupdate = 0;
	end
end